## crafty 14.11

=== Makefile ===
# To build crafty:
#
#         Uncomment the sections relevant to your architecture.
#	  You may need to tune the two gcc lines below to match your compiler.
#	  You want to set up for maximum optimization, but typically you will
#	  need to experiment to see which options provide the fastest code.
#	  This is optimized for pgcc, which is a fairly current compiler.
#   
#   The currently available targets:
#
#     AIX      {IBM machines running AIX}
#     ALPHA    {DEC Alpha running OSF/1-Digital Unix}
#     CRAY1    {any Cray-1 compatible architecture including XMP, YMP, 
#               C90, etc.}
#     HP       {HP workstation running HP_UX operating system (unix)}
#     LINUX    {80X86 architecture running LINUX (unix)}
#     NT_i386  {80X86 architecture running Windows 95 or NT}
#     NT_AXP   {DEC Alpha running Windows NT}
#     DOS      {PC running dos/windows, using DJGPP port of gcc to compile}
#     NEXT     {NextStep}
#     OS/2     {IBM OS/2 warp}
#     SGI      {SGI Workstation running Irix (SYSV/R4) Unix}
#     SUN      {Sun SparcStation running Solaris (SYSV/R4) Unix}
#     SUN_BSD  {Sun SparcStation running SunOS (BSD) Unix}
#     FreeBSD  {80X86 architecture running FreeBSD (unix)}
#   
#   The next options are optimizations inside Crafty that you will have
#   test to see if they help.  on some machines, these will slow things
#   by up to 10%, while on other machines these options will result in
#   improving search speed up to 20%.  NOTE:  if you are running Linux
#   or have a SUN Sparc-20 machine, the default configurations below
#   will use the hand-written assembly modules.  Typical performance
#   improvement is 33%, but this only applies to X86 machines and the
#   Sun Sparc-20.
#   
#   1.  opt = -DCOMPACT_ATTACKS
#   2.  opt = -DCOMPACT_ATTACKS -DUSE_SPLIT_SHIFTS
#   3.  opt = -DCOMPACT_ATTACKS -DUSE_SPLIT_SHIFTS -DUSE_ATTACK_FUNCTIONS
#   

# AIX
#target  = AIX
#CC      = cc
#CFLAGS  = -O2
#LDFLAGS =
#opt     = -DCOMPACT_ATTACKS -DUSE_SPLIT_SHIFTS -DUSE_ATTACK_FUNCTIONS

# ALPHA
#target  = ALPHA
#CC      = gcc
#CFLAGS  = -O4
#LDFLAGS =
#opt     = -DCOMPACT_ATTACKS

# DOS
# target  = DOS
# CC      = gcc
# CFLAGS  = -fomit-frame-pointer -m486 -O3
# LDFLAGS =
# opt     = -DCOMPACT_ATTACKS -DUSE_SPLIT_SHIFTS -DUSE_ATTACK_FUNCTIONS \
#           -DUSE_ASSEMBLY_A -DUSE_ASSEMBLY_B
# asm     = X86.o

# FreeBSD (gcc 2.6.3)
#target  = FreeBSD
#CC      = gcc
#CFLAGS  = -fomit-frame-pointer -m486 -O3 -Wall
#LDFLAGS = 
#opt     = -DCOMPACT_ATTACKS -DUSE_SPLIT_SHIFTS -DUSE_ATTACK_FUNCTIONS \
#          -DUSE_ASSEMBLY_A -DUSE_ASSEMBLY_B -DFAST

# HP
#target  = HP
#CC      = cc
#OPT     = +O3 +Onolimit
#CFLAGS  = +ESlit -Ae +w1
#LDFLAGS = $(OPT) $(CFLAGS)
#opt     = 
 

# LINUX
# Note: You have to uncomment exactly ONE of the `asm' lines below.
target  = LINUX
CC      = gcc
CFLAGS  = -fomit-frame-pointer -O2 -Wall
LDFLAGS = 
opt     = -DCOMPACT_ATTACKS -DUSE_SPLIT_SHIFTS -DUSE_ATTACK_FUNCTIONS \
          -DFAST

# Uncomment the FIRST `asm' line for a.out systems.
# Uncomment the SECOND `asm' line for ELF systems.
#
#asm     = X86-aout.o
#asm     = X86-elf.o

# NEXT
#target  = NEXT
#CC      = /bin/cc
#CFLAGS  = -O2
#LDFLAGS = $(CFLAGS)
#opt     = -DCOMPACT_ATTACKS

# OS2 (emx09c)
#  target  = OS2
#  CC      = gcc
#  CFLAGS  = -fomit-frame-pointer -m486 -O3 -Wall
#  LDFLAGS = -Zexe -Zcrtdll -s
#  opt = -DCOMPACT_ATTACKS -DUSE_SPLIT_SHIFTS -DUSE_ATTACK_FUNCTIONS \
#        -DUSE_ASSEMBLY_A -DUSE_ASSEMBLY_B -DFAST -DOS2
#  asm     = X86.o

# SGI
#target  = SGI
#AS      = /bin/as
#CC      = cc
#AFLAGS  = -P
#CFLAGS  = -g -32 -mips2 -cckr
#LDFLAGS = 
#opt     = -DCOMPACT_ATTACKS -DUSE_SPLIT_SHIFTS -DUSE_ATTACK_FUNCTIONS
#opt     = 

# SUN
#target  = SUN
#AS      = /usr/ccs/bin/as
#CC      = cc
#AFLAGS  = -P
#CFLAGS  = -fast -xO5 -xunroll=20
#LDFLAGS = 
#opt     = -DCOMPACT_ATTACKS -DUSE_SPLIT_SHIFTS -DUSE_ATTACK_FUNCTIONS \
#          -DUSE_ASSEMBLY_A
#asm     = Sparc.o

# Do not change anything below this line!

opts = $(opt) -D$(target)

objects = searchr.o search.o repeat.o next.o nextr.o history.o nexte.o        \
        quiesce.o evaluate.o movgen.o make.o unmake.o lookup.o store.o        \
        attacks.o swap.o boolean.o draw.o utility.o valid.o book.o data.o     \
        drawn.o edit.o enprise.o epd.o epdglue.o init.o input.o interupt.o    \
        iterate.o main.o option.o output.o phase.o ponder.o preeval.o         \
        resign.o root.o learn.o setboard.o test.o time.o validate.o           \
        annotate.o analyze.o evtest.o bench.o $(asm)

includes = data.h chess.h

epdincludes = epd.h epddefs.h epdglue.h

eval_users = data.o evaluate.o preeval.o 

crafty:	$(objects) 
	@echo $(CC) $(LDFLAGS) -o crafty {object files} -lm
	@$(CC) $(LDFLAGS) -o crafty $(objects) -lm
	@rm -f X86-elf.S
	@rm -f X86-aout.S

clean:
	-rm -f *.o crafty X86-elf.X X86-aout.S

$(objects): $(includes)

$(eval_users): evaluate.h

epd.o epdglue.o option.o init.o : $(epdincludes)

.c.o:
	@echo $(CC) $(CFLAGS) -c $*.c
	@$(CC) $(CFLAGS) $(opts) -c $*.c

.s.o:
	$(AS) $(AFLAGS) -o $*.o $*.s

X86-aout.o:
	@cp X86.s X86-aout.S
	@$(CC) -c X86-aout.S
	@rm X86-aout.S

X86-elf.o:
	@sed -e '/ _/s// /' -e '/^_/s///' X86.s > X86-elf.S
	@$(CC) -c X86-elf.S
	@rm X86-elf.S

## crafty 15.20-2

=== Makefile ===
--- 
+++ 
@@ -1,3 +1,4 @@
+
 # To build crafty:
 #
 #         Uncomment the sections relevant to your architecture.
@@ -37,7 +38,10 @@
 #   2.  opt = -DCOMPACT_ATTACKS -DUSE_SPLIT_SHIFTS
 #   3.  opt = -DCOMPACT_ATTACKS -DUSE_SPLIT_SHIFTS -DUSE_ATTACK_FUNCTIONS
 #   
-
+#   Finally, if you have a Symmetric MultiProcessor machine, you should
+#   add -DSMP to the opt definition for your make configuration, and then
+#   add -DCPUS=N where N is the number of processors (max) you will use.
+#   
 # AIX
 #target  = AIX
 #CC      = cc
@@ -45,12 +49,16 @@
 #LDFLAGS =
 #opt     = -DCOMPACT_ATTACKS -DUSE_SPLIT_SHIFTS -DUSE_ATTACK_FUNCTIONS
 
+#opt     = -DCOMPACT_ATTACKS
 # ALPHA
 #target  = ALPHA
-#CC      = gcc
-#CFLAGS  = -O4
-#LDFLAGS =
-#opt     = -DCOMPACT_ATTACKS
+#CC      = cc
+#CFLAGS  = -O0 -pthread -newc -tune host
+#LDFLAGS = $(CFLAGS)
+#LIBS    = -lpthread -lexc
+##opt    = -DSMP -DCPUS=8 -DMUTEX -DFAST -DPOSIX
+#opt     = -DSMP -DCPUS=8 -DFAST -DPOSIX
+
 
 # DOS
 # target  = DOS
@@ -69,6 +77,14 @@
 #opt     = -DCOMPACT_ATTACKS -DUSE_SPLIT_SHIFTS -DUSE_ATTACK_FUNCTIONS \
 #          -DUSE_ASSEMBLY_A -DUSE_ASSEMBLY_B -DFAST
 
+# FreeBSD (pgcc)
+#target  = FreeBSD
+#CC      = gcc
+#CFLAGS  = -pipe -D_REENTRANT -mpentium -O -Wall
+#LDFLAGS = 
+#opt     = -DCOMPACT_ATTACKS -DUSE_SPLIT_SHIFTS -DUSE_ATTACK_FUNCTIONS \
+#          -DUSE_ASSEMBLY_A -DUSE_ASSEMBLY_B -DFAST
+
 # HP
 #target  = HP
 #CC      = cc
@@ -76,22 +92,24 @@
 #CFLAGS  = +ESlit -Ae +w1
 #LDFLAGS = $(OPT) $(CFLAGS)
 #opt     = 
- 
 
 # LINUX
 # Note: You have to uncomment exactly ONE of the `asm' lines below.
 target  = LINUX
 CC      = gcc
-CFLAGS  = -fomit-frame-pointer -O2 -Wall
-LDFLAGS = 
+DEB =	-DBOOKDIR=\"/usr/lib/games/crafty\" \
+	-DTBDIR=\"/usr/lib/games/crafty/TB\" \
+	-DLOGDIR=\".\"
+CFLAGS  = -pipe -D_REENTRANT -O3 -Wall $(DEB)
+LDFLAGS = -lpthread
 opt     = -DCOMPACT_ATTACKS -DUSE_SPLIT_SHIFTS -DUSE_ATTACK_FUNCTIONS \
-          -DFAST
+          -DUSE_ASSEMBLY_A -DUSE_ASSEMBLY_B -DFAST -DSMP -DCPUS=4
 
 # Uncomment the FIRST `asm' line for a.out systems.
 # Uncomment the SECOND `asm' line for ELF systems.
 #
 #asm     = X86-aout.o
-#asm     = X86-elf.o
+asm     = X86-elf.o
 
 # NEXT
 #target  = NEXT
@@ -125,21 +143,21 @@
 #CC      = cc
 #AFLAGS  = -P
 #CFLAGS  = -fast -xO5 -xunroll=20
-#LDFLAGS = 
+#LDFLAGS = -lpthread
 #opt     = -DCOMPACT_ATTACKS -DUSE_SPLIT_SHIFTS -DUSE_ATTACK_FUNCTIONS \
-#          -DUSE_ASSEMBLY_A
+#          -DUSE_ASSEMBLY_A -DSMP -DCPUS=4 -DMUTEX -DPOSIX
 #asm     = Sparc.o
 
 # Do not change anything below this line!
 
 opts = $(opt) -D$(target)
 
-objects = searchr.o search.o repeat.o next.o nextr.o history.o nexte.o        \
-        quiesce.o evaluate.o movgen.o make.o unmake.o lookup.o store.o        \
-        attacks.o swap.o boolean.o draw.o utility.o valid.o book.o data.o     \
-        drawn.o edit.o enprise.o epd.o epdglue.o init.o input.o interupt.o    \
-        iterate.o main.o option.o output.o phase.o ponder.o preeval.o         \
-        resign.o root.o learn.o setboard.o test.o time.o validate.o           \
+objects = searchr.o search.o thread.o searchmp.o repeat.o next.o nexte.o      \
+        nextr.o history.o quiesce.o evaluate.o movgen.o make.o unmake.o       \
+        lookup.o store.o attacks.o swap.o boolean.o draw.o utility.o valid.o  \
+        book.o data.o drawn.o edit.o enprise.o epd.o epdglue.o init.o input.o \
+        interupt.o iterate.o main.o option.o output.o phase.o ponder.o        \
+        preeval.o resign.o root.o learn.o setboard.o test.o time.o validate.o \
         annotate.o analyze.o evtest.o bench.o $(asm)
 
 includes = data.h chess.h
@@ -150,7 +168,7 @@
 
 crafty:	$(objects) 
 	@echo $(CC) $(LDFLAGS) -o crafty {object files} -lm
-	@$(CC) $(LDFLAGS) -o crafty $(objects) -lm
+	@$(CC) $(LDFLAGS) -o crafty $(objects) -lm  $(LIBS)
 	@rm -f X86-elf.S
 	@rm -f X86-aout.S

=== debian/changelog ===
crafty (15.20-2) unstable; urgency=low

  * Corrected maintainer's address.

 -- Paul Serice <ugs@debian.org>  Sat, 17 Oct 1998 10:43:09 -0500

crafty (15.20-1) unstable; urgency=low

  * Added the book of opening moves.
  * Added a /etc/craftyrc global configuration file.
  * Moved Crafty into free.
  * Bug fix in upstream source that was causing crafty to crash
    if the position.lrn file was read only.
  * New upstream source.
  * New maintainer.

 -- Paul Serice <ugs@debian.org>  Sat,  3 Oct 1998 21:40:09 -0500

crafty (14.12-1) unstable; urgency=low

  * New upstream.

 -- Ole J. Tetlie <olet@debian.org>  Sat, 21 Mar 1998 13:16:11 +0100

crafty (14.11-2) frozen unstable; urgency=low

  * Added undocumented manpage.
  * Fixed bug in source distribution. (#19783)

 -- Ole J. Tetlie <olet@debian.org>  Fri, 20 Mar 1998 21:40:28 +0100

crafty (14.11-1) unstable; urgency=low

  * Initial debianization.

 -- Ole J. Tetlie <olet@debian.org>  Mon,  9 Mar 1998 11:24:27 +0100

Local variables:
mode: debian-changelog
End:

=== debian/control ===
Source: crafty
Section: games
Priority: optional
Maintainer: Paul Serice <ugs@debian.org>
Standards-Version: 2.4.1

Package: crafty
Architecture: any
Depends: ${shlibs:Depends}
Suggests: xboard
Description: Chess playing program
 Crafty is a strong chess program. It performs better than gnuchess
 in most positions. Crafty is compatible with xboard and is updated
 frequently.

=== debian/rules ===
#!/usr/bin/make -f
# Made with the aid of debmake, by Christoph Lameter,
# based on the sample debian/rules file for GNU hello by Ian Jackson.

package=crafty

build:
	$(checkdir)
	make
	touch build

clean:
	$(checkdir)
	-rm -f build
	-make clean
	-rm -f `find . -name "*~"`
	-rm -rf debian/tmp debian/files* core debian/substvars
	-rm -f game* log* position* books.bin book.bin

binary-indep: checkroot build
	$(checkdir)
# There are no architecture-independent files to be uploaded
# generated by this package.  If there were any they would be
# made here.

binary-arch: checkroot build
	$(checkdir)
	-rm -rf debian/tmp
	install -d debian/tmp
	cd debian/tmp && install -d `cat ../dirs`
	install -s crafty debian/tmp/usr/games
	cp debian/craftywatch debian/tmp/usr/games
	chmod 755 debian/tmp/usr/games/craftywatch
#	Build the opening books.
	echo "book create debian/medtosmall.txt 60" \
	     | debian/tmp/usr/games/crafty
	echo "books create debian/start.pgn 60" \
	     | debian/tmp/usr/games/crafty
#	When you create the books above, you also create these extra files.
	-rm -f /usr/lib/games/crafty/position.bin
	-rm -f /usr/lib/games/crafty/position.lrn
	-rm -f /usr/lib/games/crafty/book.lrn
	cp books.bin debian/tmp/usr/lib/games/crafty
	cp book.bin debian/tmp/usr/lib/games/crafty
	chmod 644 debian/tmp/usr/lib/games/crafty/books.bin
	chmod 644 debian/tmp/usr/lib/games/crafty/book.bin
	cp debian/crafty.doc debian/tmp/usr/doc/crafty
	cp debian/crafty.faq debian/tmp/usr/doc/crafty
	cp debian/read.me debian/tmp/usr/doc/crafty
	chmod 644 debian/tmp/usr/doc/crafty/crafty.doc
	chmod 644 debian/tmp/usr/doc/crafty/crafty.faq
	chmod 644 debian/tmp/usr/doc/crafty/read.me
#	debstd gzips the next two.
#	gzip -9 debian/tmp/usr/doc/crafty/crafty.doc
#	gzip -9 debian/tmp/usr/doc/crafty/crafty.faq
	gzip -9 debian/tmp/usr/doc/crafty/read.me
	ln -sf ../man7/undocumented.7.gz debian/tmp/usr/man/man6/crafty.6.gz
	ln -sf ../man7/undocumented.7.gz \
               debian/tmp/usr/man/man6/craftywatch.6.gz
	cp debian/craftyrc debian/tmp/etc
# Must have debmake installed for this to work. Otherwise please copy
# /usr/bin/debstd into the debian directory and change debstd to debian/debstd
	debstd 
	dpkg-gencontrol
	chown -R root.root debian/tmp
	chmod -R go=rX debian/tmp
	dpkg --build debian/tmp ..

define checkdir
	test -f debian/rules
endef

binary: binary-indep binary-arch

checkroot:
	$(checkdir)
	test root = "`whoami`"

.PHONY: binary binary-arch binary-indep clean checkroot

## crafty 17.6

=== Makefile ===

# To build crafty:
#
#         Uncomment the sections relevant to your architecture.
#	  You may need to tune the two gcc lines below to match your compiler.
#	  You want to set up for maximum optimization, but typically you will
#	  need to experiment to see which options provide the fastest code.
#	  This is optimized for pgcc, which is a fairly current compiler.
#   
#   The currently available targets:
#
#     AIX      {IBM machines running AIX}
#     ALPHA    {DEC Alpha running OSF/1-Digital Unix}
#     CRAY1    {any Cray-1 compatible architecture including XMP, YMP, 
#               C90, etc.}
#     HP       {HP workstation running HP_UX operating system (unix)}
#     LINUX    {80X86 architecture running LINUX (unix)}
#     NT_i386  {80X86 architecture running Windows 95 or NT}
#     NT_AXP   {DEC Alpha running Windows NT}
#     DOS      {PC running dos/windows, using DJGPP port of gcc to compile}
#     NEXT     {NextStep}
#     OS/2     {IBM OS/2 warp}
#     SGI      {SGI Workstation running Irix (SYSV/R4) Unix}
#     SUN      {Sun SparcStation running Solaris (SYSV/R4) Unix}
#     SUN_BSD  {Sun SparcStation running SunOS (BSD) Unix}
#     FreeBSD  {80X86 architecture running FreeBSD (unix)}
#   
#   The next options are optimizations inside Crafty that you will have
#   test to see if they help.  on some machines, these will slow things
#   by up to 10%, while on other machines these options will result in
#   improving search speed up to 20%.  NOTE:  if you are running Linux
#   or have a SUN Sparc-20 machine, the default configurations below
#   will use the hand-written assembly modules.  Typical performance
#   improvement is 33%, but this only applies to X86 machines and the
#   Sun Sparc-20.
#   
#   1.  opt = -DCOMPACT_ATTACKS
#   2.  opt = -DCOMPACT_ATTACKS -DUSE_ATTACK_FUNCTIONS
#   
#   Finally, if you have a Symmetric MultiProcessor machine, you should
#   add -DSMP to the opt definition for your make configuration, and then
#   add -DCPUS=N where N is the number of processors (max) you will use.
#   
#   if you want 6 man EGTB support, you will need to add -DEGTB6 to the
#   options above.
#   
#   
# AIX
#target  = AIX
#CC      = cc
#CFLAGS  = -O2
#CPP	 = $(CC)
#LDFLAGS =
#opt     = -DCOMPACT_ATTACKS -DUSE_ATTACK_FUNCTIONS
#opt     = -DCOMPACT_ATTACKS

# ALPHA
#target  = ALPHA
#CC      = cc
#Note: "-arch host" assumes you will run the binary on exactly the
# same kind of ALPHA you compiled it on.  Omit it if you want to run
# the same binary on several kinds of Alpha.  If you are on an early
# EV6 that does not have the CIX instruction set extension, a compiler
# bug (?) causes these instructions to be generated anyway.  If this
# happens you'll see a message about "instr emulated" after starting
# crafty; to fix it, change "-arch host" to "-arch ev56 -tune host"
# and recompile.
#CFLAGS  = -std -fast -O4 -pthread -newc -arch host
#CPP	 = cxx
#LDFLAGS = $(CFLAGS)
#LIBS    = -lpthread -lexc
#opt     = -DSMP -DCPUS=8 -DFAST -DPOSIX


# DOS
# target  = DOS
# CC      = gcc
# CFLAGS  = -fomit-frame-pointer -m486 -O3
# CPP	  = $(CC)
# LDFLAGS =
# opt     = -DCOMPACT_ATTACKS -DUSE_ATTACK_FUNCTIONS \
#           -DUSE_ASSEMBLY_A -DUSE_ASSEMBLY_B
# asm     = X86.o

# FreeBSD (gcc 2.6.3)
#target  = FreeBSD
#CC      = gcc
#CFLAGS  = -fomit-frame-pointer -m486 -O3 -Wall
#CPP	 = $(CC)
#LDFLAGS = 
#opt     = -DCOMPACT_ATTACKS -DUSE_ATTACK_FUNCTIONS \
#          -DUSE_ASSEMBLY_A -DUSE_ASSEMBLY_B -DFAST

# FreeBSD (pgcc)
#target  = FreeBSD
#CC      = gcc
#CFLAGS  = -pipe -D_REENTRANT -mpentium -O -Wall
#CPP	 = $(CC)
#LDFLAGS = 
#opt     = -DCOMPACT_ATTACKS -DUSE_ATTACK_FUNCTIONS \
#          -DUSE_ASSEMBLY_A -DUSE_ASSEMBLY_B -DFAST

# HP
#target  = HP
#CC      = cc
#OPT     = +O3 +Onolimit
#CFLAGS  = +ESlit -Ae +w1
#CPP	 = $(CC)
#LDFLAGS = $(OPT) $(CFLAGS)
#opt     = 
 
# LINUX (gcc 2.95)
# Note: You have to uncomment exactly ONE of the `asm' lines below.
target  = LINUX
CC      = gcc
CPP	= g++
CFLAGS  = -Wall -pipe -D_REENTRANT -march=i686 -O -fforce-mem \
          -fomit-frame-pointer
LDFLAGS = -lpthread
opt     = -DCOMPACT_ATTACKS -DUSE_ATTACK_FUNCTIONS \
          -DUSE_ASSEMBLY_A -DUSE_ASSEMBLY_B -DFAST -DSMP -DCPUS=4 -DDGT

# Uncomment the FIRST `asm' line for a.out systems.
# Uncomment the SECOND `asm' line for ELF systems.
#
#asm     = X86-aout.o
asm     = X86-elf.o
 
# NEXT
#target  = NEXT
#CC      = /bin/cc
#CFLAGS  = -O2
#CPP	 = $(CC)
#LDFLAGS = $(CFLAGS)
#opt     = -DCOMPACT_ATTACKS

# OS2 (emx09c)
#  target  = OS2
#  CC      = gcc
#  CFLAGS  = -fomit-frame-pointer -m486 -O3 -Wall
#  CPP     = $(CC)
#  LDFLAGS = -Zexe -Zcrtdll -s
#  opt = -DCOMPACT_ATTACKS -DUSE_ATTACK_FUNCTIONS \
#        -DUSE_ASSEMBLY_A -DUSE_ASSEMBLY_B -DFAST -DOS2
#  asm     = X86.o

# SGI
#target  = SGI
#AS      = /bin/as
#CC      = cc
#AFLAGS  = -P
#CFLAGS  = -g -32 -mips2 -cckr
#CPP	 = $(CC)
#LDFLAGS = 
#opt     = -DCOMPACT_ATTACKS -DUSE_ATTACK_FUNCTIONS
#opt     = 

# SUN
#target  = SUN
#AS      = /usr/ccs/bin/as
#CC      = cc
#AFLAGS  = -P
#CPP	 = $(CC)
#CFLAGS  = -fast -xO5 -xunroll=20
#LDFLAGS = -lpthread
#opt     = -DCOMPACT_ATTACKS -DUSE_ATTACK_FUNCTIONS \
#          -DUSE_ASSEMBLY_A -DSMP -DCPUS=4 -DMUTEX -DPOSIX
#asm     = Sparc.o

# Do not change anything below this line!

opts = $(opt) -D$(target)

objects = searchr.o search.o thread.o searchmp.o repeat.o next.o nexte.o      \
       nextr.o history.o quiesce.o evaluate.o movgen.o make.o unmake.o hash.o \
       attacks.o swap.o boolean.o utility.o valid.o probe.o book.o data.o     \
       drawn.o edit.o enprise.o epd.o epdglue.o init.o input.o interupt.o     \
       iterate.o main.o option.o output.o phase.o ponder.o preeval.o resign.o \
       root.o learn.o setboard.o test.o time.o validate.o annotate.o          \
       analyze.o evtest.o bench.o egtb.o dgt.o $(asm)

includes = data.h chess.h

epdincludes = epd.h epddefs.h epdglue.h

eval_users = data.o evaluate.o preeval.o 

crafty:	$(objects) 
	$(CC) $(LDFLAGS) -o crafty $(objects) -lm  $(LIBS)
	@rm -f X86-elf.S
	@rm -f X86-aout.S

dgt:    dgtdrv.o
	@cc -O -o dgt dgtdrv.c

egtb.o: egtb.cpp
	$(CPP) -c $(CFLAGS) $(opts) egtb.cpp
clean:
	-rm -f *.o crafty X86-elf.X X86-aout.S

$(objects): $(includes)

$(eval_users): evaluate.h

epd.o epdglue.o option.o init.o : $(epdincludes)

.c.o:
	$(CC) $(CFLAGS) $(opts) -c $*.c

.s.o:
	$(AS) $(AFLAGS) -o $*.o $*.s

X86-aout.o:
	sed -e 's/ALIGN/4/' X86.s > X86-aout.S
	$(CC) -c X86-aout.S
	@rm X86-aout.S

X86-elf.o:
	sed -e '/ _/s// /' -e '/^_/s///' -e 's/ALIGN/16/' X86.s > X86-elf.S
	$(CC) -c X86-elf.S
	@rm X86-elf.S

## crafty 18.12

=== Makefile ===
# To build crafty:
#
#	  You want to set up for maximum optimization, but typically you will
#	  need to experiment to see which options provide the fastest code.
#	  This is optimized for pgcc, which is a fairly current compiler.
#   
#   The currently available targets:
#
#     AIX        {IBM machines running AIX}
#     ALPHA      {DEC Alpha running OSF/1-Digital Unix}
#     ALPHALINUX {DEC Alpha running Linux}
#     CRAY1      {any Cray-1 compatible architecture including XMP, YMP, 
#                 C90, etc.}
#     HP         {HP workstation running HP_UX operating system (Unix)}
#     LINUX      {80X86 architecture running LINUX (Unix)}
#     NT_i386    {80X86 architecture running Windows 95 or NT}
#     NT_AXP     {DEC Alpha running Windows NT}
#     DOS        {PC running dos/windows, using DJGPP port of gcc to compile}
#     NEXT       {NextStep}
#     OS/2       {IBM OS/2 warp}
#     SGI        {SGI Workstation running Irix (SYSV/R4) Unix}
#     SUN        {Sun SparcStation running Solaris (SYSV/R4) Unix}
#     SUN_GCC    {Sun SparcStation running Solaris but using gcc
#     FreeBSD    {80X86 architecture running FreeBSD (Unix)}
#     NetBSD     {multi-architecture running NetBSD (Unix)}
#     Cygwin     {80X86 running Cygwin under Win32 (Unix)}
#   
#   The next options are optimizations inside Crafty that you will have
#   test to see if they help.  on some machines, these will slow things
#   by up to 10%, while on other machines these options will result in
#   improving search speed up to 20%.  NOTE:  if you are running Linux
#   or have a SUN Sparc-20 machine, the default configurations below
#   will use the hand-written assembly modules.  Typical performance
#   improvement is 33%, but this only applies to X86 machines and the
#   Sun Sparc-20.
#   
#   1.  opt = -DCOMPACT_ATTACKS
#   2.  opt = -DCOMPACT_ATTACKS -DUSE_ATTACK_FUNCTIONS
#   
#   Finally, if you have a Symmetric MultiProcessor machine, you should
#   add -DSMP to the opt definition for your make configuration, and then
#   add -DCPUS=N where N is the number of processors (max) you will use.
#   
#   if you want 6 man EGTB support, you will need to add -DEGTB6 to the
#   options above.

default:
	$(MAKE) -j linux-i686-elf
help:
	@echo "You must specify the system which you want to compile for:"
	@echo ""
	@echo "make aix              IBM AIX"
	@echo "make alpha            DEC Alpha with OSF/1-Digital UNIX"
	@echo "make alpha-host       Alpha DECstation optimized for host"
	@echo "make alpha-host-nocix Alpha DECstation optimezed for host, no CIX insn"
	@echo "make cygwin           Cygwin under Win32"
	@echo "make dos              DOS on i386 with DJGPP"
	@echo "make hpux             HP/UX 9/10, /7xx"
	@echo "make linux            Linux optimized for i386"
	@echo "make linux-elf        Linux optimized for i386, ELF format"
	@echo "make linux-i686       Linux optimized for i686"
	@echo "make linux-i686-elf   Linux optimized for i686, ELF format"
	@echo "make linux-alpha      Linux optimized for alpha"
	@echo "make freebsd          FreeBSD"
	@echo "make freebsd-pgcc     FreeBSD using Pentium GNU cc"
	@echo "make netbsd           NetBSD"
	@echo "make netbsd-i386      NetBSD optimized for i386"
	@echo "make netbsd-i386-elf  NetBSD optimized for i386, ELF format"
	@echo "make netbsd-sparc     NetBSD optimized for sparc"
	@echo "make next             NeXTSTEP"
	@echo "make os2              IBM OS/2 Warp"
	@echo "make sgi              SGI running IRIX"
	@echo "make solaris          Solaris 2.x"
	@echo "make solaris-gcc      Solaris 2.x using GNU cc"
	@echo ""
	@echo "make generic          Try this one if your system isn't listed above;"
	@echo "                      it assumes you have installed GNU cc"
	@echo ""

aix:
	$(MAKE) target=AIX \
		CC=cc CXX='$$(CC)' \
		CFLAGS='$(CFLAGS} -O2' \
		LDFLAGS='$(LDFLAGS)' \
		opt='$(opt) -DCOMPACT_ATTACKS -DUSE_ATTACK_FUNCTIONS' \
		crafty-make

#Note: "-arch host" assumes you will run the binary on exactly the
# same kind of ALPHA you compiled it on.  Omit it if you want to run
# the same binary on several kinds of Alpha.  If you are on an early
# EV6 that does not have the CIX instruction set extension, a compiler
# bug (?) causes these instructions to be generated anyway.  If this
# happens you'll see a message about "instr emulated" after starting
# crafty; to fix it, change "-arch host" to "-arch ev56 -tune host"
# and recompile.

alpha:
	$(MAKE) target=ALPHA \
		CC=cc CXX=cxx \
		CFLAGS='$(CFLAGS) -std -fast -O4 -pthread -newc' \
		LDFLAGS='$(LDFLAGS) $(CFLAGS)' \
		LIBS='-lpthread -lexc' \
		opt='$(opt) -DSMP -DCPUS=8 -DFAST -DPOSIX' \
		crafty-make

alpha-host:
	$(MAKE) target=ALPHA \
		CC=cc CXX=cxx \
		CFLAGS='$(CFLAGS) -std -fast -O4 -pthread -newc -arch host' \
		LDFLAGS='$(LDFLAGS) $(CFLAGS)' \
		LIBS='-lpthread -lexc' \
		opt='$(opt) -DSMP -DCPUS=8 -DFAST -DPOSIX' \
		crafty-make

alpha-host-nocix:
	$(MAKE) target=ALPHA \
		CC=cc CXX=cxx \
		CFLAGS='$(CFLAGS) -std -fast -O4 -pthread -newc \
			-arch ev56 -tune host' \
		LDFLAGS='$(LDFLAGS) $(CFLAGS)' \
		LIBS='-lpthread -lexc' \
		opt='$(opt) -DSMP -DCPUS=8 -DFAST -DPOSIX' \
		crafty-make

cygwin:
	$(MAKE) target=LINUX \
		CC=gcc CXX='$$(CC)' \
		CFLAGS='$(CFLAGS) -pipe -D_REENTRANT -mpentium -O2 -Wall' \
		LDFLAGS='$(LDFLAGS)' \
		opt='$(opt) -DCOMPACT_ATTACKS -DUSE_ATTACK_FUNCTIONS \
		     -DUSE_ASSEMBLY_A -DUSE_ASSEMBLY_B -DFAST' \
		asm=X86-aout.o \
		crafty-make

dos:
	$(MAKE) target=DOS \
		CC=gcc CXX='$$(CC)' \
		CFLAGS='$(CFLAGS) -fomit-frame-pointer -m486 -O3' \
		LDFLAGS='$(LDFLAGS)' \
		opt='$(opt) -DCOMPACT_ATTACKS -DUSE_ATTACK_FUNCTIONS \
		     -DUSE_ASSEMBLY_A -DUSE_ASSEMBLY_B' \
		asm='X86.o' \
		crafty-make

freebsd:
	$(MAKE) target=FreeBSD \
		CC=gcc CXX='$$(CC)' \
		CFLAGS='$(CFLAGS) -fomit-frame-pointer -m486 -O3 -Wall' \
		LDFLAGS='$(LDFLAGS)' \
		opt='$(opt) -DCOMPACT_ATTACKS -DUSE_ATTACK_FUNCTIONS \
		     -DUSE_ASSEMBLY_A -DUSE_ASSEMBLY_B -DFAST' \
		asm=X86-elf.o \
		crafty-make

freebsd-pgcc:
	$(MAKE) target=FreeBSD \
		CC=gcc CXX='$$(CC)' \
		CFLAGS='$(CFLAGS) -pipe -D_REENTRANT -mpentium -O -Wall' \
		LDFLAGS='$(LDFLAGS)' \
		opt='$(opt) -DCOMPACT_ATTACKS -DUSE_ATTACK_FUNCTIONS \
		     -DUSE_ASSEMBLY_A -DUSE_ASSEMBLY_B -DFAST' \
		asm=X86-elf.o \
		crafty-make

hpux:
	$(MAKE) target=HP \
		CC=cc CXX='$$(CC)' \
		CFLAGS='$(CFLAGS) +ESlit -Ae +w1' \
		LDFLAGS='$(LDFLAGS) +O3 +Onolimit $(CFLAGS)' \
		crafty-make

linux:
	$(MAKE) target=LINUX \
		CC=gcc CXX=g++ \
		CFLAGS='$(CFLAGS) -Wall -pipe -D_REENTRANT -O3 \
			-fforce-mem -fomit-frame-pointer' \
		LDFLAGS='$(LDFLAGS) -lpthread' \
		opt='$(opt) -DCOMPACT_ATTACKS -DUSE_ATTACK_FUNCTIONS \
		     -DUSE_ASSEMBLY_A -DUSE_ASSEMBLY_B -DFAST' \
		asm=X86-aout.o \
		crafty-make

linux-elf:
	$(MAKE) target=LINUX \
		CC=gcc CXX=g++ \
		CFLAGS='$(CFLAGS) -Wall -pipe -D_REENTRANT -O3 \
			-fforce-mem -fomit-frame-pointer' \
		LDFLAGS='$(LDFLAGS) -lpthread' \
		opt='$(opt) -DCOMPACT_ATTACKS -DUSE_ATTACK_FUNCTIONS \
		     -DUSE_ASSEMBLY_A -DUSE_ASSEMBLY_B -DFAST' \
		asm=X86-elf.o \
		crafty-make

linux-i686:
	$(MAKE) target=LINUX \
		CC=gcc CXX=g++ \
		CFLAGS='$(CFLAGS) -Wall -pipe -D_REENTRANT -march=i686 -O \
			-fforce-mem -fomit-frame-pointer \
			-mpreferred-stack-boundary=2' \
		LDFLAGS='$(LDFLAGS) -lpthread' \
		opt='$(opt) -DCOMPACT_ATTACKS -DUSE_ATTACK_FUNCTIONS \
		     -DUSE_ASSEMBLY_A -DUSE_ASSEMBLY_B -DFAST \
		     -DSMP -DCPUS=4 -DDGT' \
		asm=X86-aout.o \
		crafty-make

linux-i686-elf:
	$(MAKE) target=LINUX \
		CC=gcc CXX=g++ \
		CFLAGS='$(CFLAGS) -Wall -pipe -D_REENTRANT -march=i686 -O \
			-fforce-mem -fomit-frame-pointer \
			-fno-gcse -mpreferred-stack-boundary=2' \
		LDFLAGS='$(LDFLAGS)' \
		opt='$(opt) -DCOMPACT_ATTACKS -DUSE_ATTACK_FUNCTIONS \
		     -DUSE_ASSEMBLY_A -DUSE_ASSEMBLY_B -DFAST \
		     -DSMP -DCPUS=4 -DCLONE -DDGT' \
		asm=X86-elf.o \
		crafty-make

# You may wish to add additional targets called linux-alpha-<your_cpu>
# to produce optimized code for your CPU.  Just copy the linux-alpha target
# and add -mcpu=<your_cpu> to the CFLAGS, where the type of your CPU is
# ev4,ev45... or 21064,21064A...  Or, just type
#
# 	make linux-alpha CFLAGS='-mcpu=<your_cpu>'
#
# If you have the Compaq C Compiler for AlphaLinux you can link the
# machine/builtins.h from ccc's private include file to /usr/include/alpha,
# link the directory alpha to machine and remove -DNOBUILTINS from the
# opt-line.
#
# THIS TARGET IS EXPERIMENTAL !!!

linux-alpha:
	$(MAKE) target=ALPHA \
		CC=gcc CXX=g++ \
		CFLAGS='$(CFLAGS) -O4 -ffast-math -funroll-loops' \
		LDFLAGS='$(LDFLAGS) $(CFLAGS)' \
		LIBS='-lpthread' \
		opt='$(opt) -DSMP -DCPUS=8 -DFAST -DPOSIX -DNOBUILTINS' \
		crafty-make

netbsd:
	$(MAKE) target=NetBSD \
		CC=gcc CXX=g++ \
		CFLAGS='$(CFLAGS) -D_REENTRANT -O3 -Wall \
			-fomit-frame-pointer -funroll-all-loops \
			-finline-functions -ffast-math' \
		LDFLAGS='$(LDFLAGS)' \
		opt='$(opt) -DCOMPACT_ATTACKS -DUSE_ATTACK_FUNCTIONS -DFAST' \
		crafty-make

netbsd-i386:
	$(MAKE) target=NetBSD \
		CC=gcc CXX=g++ \
		CFLAGS='$(CFLAGS) -D_REENTRANT -O3 -Wall -m486 \
			-fomit-frame-pointer -funroll-all-loops \
			-finline-functions -ffast-math' \
		LDFLAGS='$(LDFLAGS)' \
		opt='$(opt) -DCOMPACT_ATTACKS -DUSE_ATTACK_FUNCTIONS -DFAST \
		     -DUSE_ASSEMBLY_A -DUSE_ASSEMBLY_B' \
		asm=X86-aout.o \
		crafty-make

netbsd-i386-elf:
	$(MAKE) target=NetBSD \
		CC=gcc CXX=g++ \
		CFLAGS='$(CFLAGS) -D_REENTRANT -O3 -Wall -m486 \
			-fomit-frame-pointer -funroll-all-loops \
			-finline-functions -ffast-math' \
		LDFLAGS='$(LDFLAGS)' \
		opt='$(opt) -DCOMPACT_ATTACKS -DUSE_ATTACK_FUNCTIONS -DFAST \
		     -DUSE_ASSEMBLY_A -DUSE_ASSEMBLY_B' \
		asm=X86-elf.o \
		crafty-make

netbsd-sparc:
	$(MAKE) target=NetBSD \
		CC=gcc CXX=g++ \
		CFLAGS='$(CFLAGS) -D_REENTRANT -O3 -Wall \
			-fomit-frame-pointer -funroll-all-loops \
			-finline-functions -ffast-math' \
		LDFLAGS='$(LDFLAGS)' \
		opt='$(opt) -DCOMPACT_ATTACKS -DUSE_ATTACK_FUNCTIONS -DFAST \
		     -DUSE_ASSEMBLY_A' \
		asm=Sparc.o \
		crafty-make

next:
	$(MAKE) target=NEXT \
		CC=/bin/cc CXX='$$(CC)' \
		CFLAGS='$(CFLAGS) -O2' \
		LDFLAGS='$(LDFLAGS) $(CFLAGS)'
		opt='$(opt) -DCOMPACT_ATTACKS' \
		crafty-make

os2:
	$(MAKE) target=OS2 \
		CC=gcc CXX='$$(CC)' \
		CFLAGS='$(CFLAGS) -fomit-frame-pointer -m486 -O3 -Wall' \
		LDFLAGS='$(LDFLAGS) -Zexe -Zcrtdll -s' \
		opt='$(opt) -DCOMPACT_ATTACKS -DUSE_ATTACK_FUNCTIONS \
		     -DUSE_ASSEMBLY_A -DUSE_ASSEMBLY_B -DFAST' \
		asm=X86.o \
		crafty-make

sgi:
	$(MAKE) target=SGI \
		AS=/bin/as CC=cc CXX='$$(CC)' \
		AFLAGS='-P' \
		CFLAGS='$(CFLAGS) -g -32 -mips2 -cckr' \
		LDFLAGS='$(LDFLAGS)' \
		opt='$(opt) -DCOMPACT_ATTACKS -DUSE_ATTACK_FUNCTIONS' \
		crafty-make

solaris:
	$(MAKE) target=SUN \
		AS=/usr/ccs/bin/as CC=cc CXX='$$(CC)' \
		AFLAGS='-P' \
		CFLAGS='$(CFLAGS) -fast -xO5 -xunroll=20' \
		LDFLAGS='$(LDFLAGS) -lpthread' \
		opt='$(opt) -DCOMPACT_ATTACKS -DUSE_ATTACK_FUNCTIONS \
		     -DUSE_ASSEMBLY_A -DSMP -DCPUS=4 -DMUTEX -DPOSIX' \
		asm=Sparc.o \
		crafty-make

solaris-gcc:
	$(MAKE) target=SUN \
		AS=/usr/ccs/bin/as CC=gcc CXX=g++ \
		AFLAGS='-P' \
		CFLAGS='$(CFLAGS) -Wall -pipe -D_REENTRANT -O2 \
			-fforce-mem -fomit-frame-pointer' \
		LDFLAGS='$(LDFLAGS)' \
		opt='$(opt) -DCOMPACT_ATTACKS -DUSE_ATTACK_FUNCTIONS \
		     -DUSE_ASSEMBLY_A' \
		asm=Sparc.o \
		crafty-make

generic:
	$(MAKE) CC=gcc CXX=g++ \
		CFLAGS='$(CFLAGS)' \
		LDFLAGS='$(LDFLAGS)' \
		crafty-make

# Do not change anything below this line!

opts = $(opt) -D$(target)

objects = searchr.o search.o thread.o searchmp.o repeat.o next.o nexte.o      \
       nextr.o history.o quiesce.o evaluate.o movgen.o make.o unmake.o hash.o \
       attacks.o swap.o boolean.o utility.o valid.o probe.o book.o data.o     \
       drawn.o edit.o epd.o epdglue.o init.o input.o interupt.o iterate.o     \
       main.o option.o output.o phase.o ponder.o preeval.o resign.o root.o    \
       learn.o setboard.o test.o testepd.o time.o validate.o annotate.o       \

## crafty 19.15

=== Makefile ===
# To build crafty:
#
#	  You want to set up for maximum optimization, but typically you will
#	  need to experiment to see which options provide the fastest code.
#	  This is optimized for gcc, which is a fairly current compiler.
#   
#   The currently available targets:
#
#     aix          {IBM machines running AIX}
#     alpha        {DEC Alpha running OSF/1-Digital Unix}
#     darwin       {PPC on Mac OSX}
#     freebsd      {80X86 architecture running FreeBSD (Unix)}
#     hpux         {HP workstation running HP_UX operating system (Unix)}
#     linux        {80X86 architecture running LINUX (Unix) (gcc)}
#     linux-alpha  {Digital Alpha processor running LINUX (Unix)}
#     linux-amd64  {AMD X86-64 (opteron) running LINUX (Unix)}
#     linux-icc    {80X86 architecture running LINUX (Unix) (Intel compiler)}
#     netbsd       {80X86 architecture running netbsd(Unix)}
#     netbsd-sparc {sparc architecture running netbsd(Unix)}
#     next         {NextStep}
#     os2          {IBM OS/2 warp}
#     sgi          {SGI Workstation running Irix (SYSV/R4) Unix}
#     solaris      {Sun SparcStation running Solaris (SYSV/R4) Unix}
#     solaris-gcc  {Sun SparcStation running Solaris but using gcc}
#   
#   The next options are optimizations inside Crafty that you will have
#   test to see if they help.  on some machines, these will slow things
#   by up to 10%, while on other machines these options will result in
#   improving search speed up to 20%.  NOTE:  if you are running Linux
#   system, the default configurations below will use the hand-written
#   assembly modules.  Typical performance improvement is 5%, but this
#   only applies to X86 machines running Linux.
#   
#   -DSMP             enables SMP support (not clustering).  If you choose
#                     this option, you need to look closely at the following
#                     four options as well.
#   -DCPUS=n          defines the maximum number of CPUS Crafty will be able
#                     to use in a SMP system.  Note that this is the max you
#                     will be able to use.  You need to use the smpmt=n command
#                     to make crafty use more than the default 1 thread.
#   -DPOSIX           This enables POSIX threads support.  You must have either
#                     -DPOSIX or custom-written lock.h code to support your 
#                     system.
#   -DMUTEX           This uses posix threads MUTEX locks, which are not as
#                     efficient as spinlocks, but are very portable.  If this
#                     option is not chosen, then lock.h has to be modified to
#                     define inline assembly lock functions.
#
#   -DBOOKDIR         path to the directory containing the book binary files.
#                     The default for all such path values is "." if you don't
#                     specify a path with this macro definition.
#   -DDETECTDRAW      This enables experimental code that detects lots of the
#                     famous blocked-pawn positions as draws.  It is much slower
#                     and perhaps slightly risky.
#   -DDGT             This is a unix-only option to support the DGT board.
#   -DEPD             if you want full EPD support built in.
#   -DFAST            This option compiles out some of the statistics 
#                     gathering to slightly speed up the code.
#   -DFUTILITY        enables "futility pruning" a forward-pruning algorithm
#                     that seems to be relatively safe.
#   -DLOGDIR          path to the directory where Crafty puts the log.nnn and
#                     game.nnn files.
#   -DRCDIR           path to the directory where we look for the .craftyrc or
#                     crafty.rc (windows) file.
#   -DTBDIR           path to the directory where the endgame tablebase files
#                     are found.  default = "./TB"
#   -DTRACE           This enables the "trace" command so that the search tree
#                     can be dumped while running.
#   -INLINE_AMD       Compiles with the Intel assembly code for FirstOne(),
#                     LastOne() and PopCnt() for the AMD opteron, only tested
#                     with the 64-bit opteron GCC compiler.
#   -INLINE_ASM       Compiles with the Intel assembly code for FirstOne(),
#                     LastOne() and PopCnt().  This is for gcc-style inlining
#                     and now works with the Intel C/C++ compiler as well.
#   

default:
	$(MAKE) -j linux-icc
help:
	@echo "You must specify the system which you want to compile for:"
	@echo ""
	@echo "make aix              IBM AIX"
	@echo "make alpha            DEC Alpha with OSF/1-Digital UNIX"
	@echo "make alpha-host       Alpha DECstation optimized for host"
	@echo "make alpha-host-nocix Alpha DECstation optimezed for host, no CIX insn"
	@echo "make darwin           Darwin on OSX"
	@echo "make hpux             HP/UX 9/10, /7xx"
	@echo "make linux            Linux optimized for i386, ELF format"
	@echo "make linux-alpha      Linux optimized for alpha"
	@echo "make linux-AMD64      Linux optimized for AMD opteron
	@echo "make freebsd          FreeBSD"
	@echo "make netbsd           NetBSD"
	@echo "make netbsd-sparc     NetBSD optimized for sparc"
	@echo "make next             NeXTSTEP"
	@echo "make os2              IBM OS/2 Warp"
	@echo "make sgi              SGI running IRIX"
	@echo "make solaris          Solaris 2.x"
	@echo "make solaris-gcc      Solaris 2.x using GNU cc"
	@echo ""
	@echo "make generic          Try this one if your system isn't listed above;"
	@echo "                      it assumes you have installed GNU cc"
	@echo ""

aix:
	$(MAKE) target=AIX \
		CC=cc CXX=$(CC) \
		CFLAGS='$(CFLAGS) -O2' \
		CXFLAGS=$(CFLAGS) \
		opt='$(opt) -DFUTILITY' \
		crafty-make

alpha:
	$(MAKE) target=ALPHA \
		CC=cc CXX=cxx \
		CFLAGS='$(CFLAGS) -std -fast -O4 -pthread -newc' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS='$(LDFLAGS) $(CFLAGS)' \
		LIBS='-lpthread -lexc' \
		opt='$(opt) -DFUTILITY -DSMP -DCPUS=8 -DFAST -DPOSIX' \
		crafty-make

alpha-host:
	$(MAKE) target=ALPHA \
		CC=cc CXX=cxx \
		CFLAGS='$(CFLAGS) -std -fast -O4 -pthread -newc -arch host' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS='$(LDFLAGS) $(CFLAGS)' \
		LIBS='-lpthread -lexc' \
		opt='$(opt) -DFUTILITY -DSMP -DCPUS=8 -DFAST -DPOSIX' \
		crafty-make

alpha-host-nocix:
	$(MAKE) target=ALPHA \
		CC=cc CXX=cxx \
		CFLAGS='$(CFLAGS) -std -fast -O4 -pthread -newc' \
		CXFLAGS='$(CFLAGS) -arch ev56 -tune host' \
		LDFLAGS='$(LDFLAGS) $(CFLAGS)' \
		LIBS='-lpthread -lexc' \
		opt='$(opt) -DFUTILITY -DSMP -DCPUS=8 -DFAST -DPOSIX' \
		crafty-make

darwin:
	$(MAKE) target=FreeBSD \
		CC=gcc CXX=g++ \
		CFLAGS='$(CFLAGS) -Wall -pipe -O3' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS=$(LDFLAGS) \
		LIBS='-lstdc++' \
		opt='$(opt) -DFUTILITY -DFAST' \
		crafty-make
		
freebsd:
	$(MAKE) target=FreeBSD \
		CC=gcc CXX='$(CC)' \
		CFLAGS='$(CFLAGS) -fomit-frame-pointer -m486 -O3 -Wall' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS=$(LDFLAGS) \
		opt='$(opt) -DFUTILITY -DUSE_ASSEMBLY -DFAST' \
		crafty-make

freebsd-pgcc:
	$(MAKE) target=FreeBSD \
		CC=gcc CXX='$(CC)' \
		CFLAGS='$(CFLAGS) -pipe -D_REENTRANT -mpentium -O -Wall' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS=$(LDFLAGS) \
		opt='$(opt) -DFUTILITY -DUSE_ASSEMBLY -DFAST' \
		crafty-make

hpux:
	$(MAKE) target=HP \
		CC=cc CXX='$(CC)' \
		CFLAGS='$(CFLAGS) +ESlit -Ae +w1' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS='$(LDFLAGS) +O3 +Onolimit $(CFLAGS)' \
		crafty-make

linux:
	$(MAKE) target=LINUX \
		CC=gcc CXX=g++ \
		CFLAGS='$(CFLAGS) -Wall -pipe -D_REENTRANT -march=i686 -O3 \
			-fbranch-probabilities -fforce-mem -fomit-frame-pointer\
			-fno-gcse -mpreferred-stack-boundary=2' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS='$(LDFLAGS) -lpthread -lstdc++' \
		opt='$(opt) -DFUTILITY -DFAST -DINLINE_ASM \
                         -DPOSIX -DSMP -DCPUS=2' \
		crafty-make

linux-amd64:
	$(MAKE) target=LINUX \
		CC=gcc CXX=g++ \
		CFLAGS='$(CFLAGS) -Wall -pipe -D_REENTRANT \
		-fomit-frame-pointer -O3' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS='$(LDFLAGS) -lpthread -lstdc++' \
		opt='$(opt) -DPOSIX -DFAST -DSMP -DCPUS=4 \
		         -DFUTILITY -DUSE_ASSEMBLY -DINLINE_AMD' \
		crafty-make

linux-profile:
	$(MAKE) target=LINUX \
		CC=gcc CXX=g++ \
		CFLAGS='$(CFLAGS) -Wall -pipe -D_REENTRANT -march=i686 -O3 \
			-fprofile-arcs -fforce-mem \
			-fno-gcse -mpreferred-stack-boundary=2' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS='$(LDFLAGS) -fprofile-arcs -lstdc++ -lpthread' \
		opt='$(opt) -DFUTILITY -DINLINE_ASM -DFAST \
		         -DPOSIX -DSMP -DCPUS=4' \
		crafty-make

linux-icc-profile:
	$(MAKE) target=LINUX \
		CC=icc CXX=icc \
		CFLAGS='$(CFLAGS) -D_REENTRANT -O2 \
                        -xN -prof_genx -prof_dir ./profdir \
                        -Ob2 -fno-alias' \
		CXFLAGS='$(CFLAGS) -D_REENTRANT -O2 \
                        -w -xN -prof_genx -prof_dir ./profdir' \
		LDFLAGS='$(LDFLAGS) -lpthread' \
		opt='$(opt) -DFUTILITY -DFAST -DINLINE_ASM \
                         -DPOSIX -DSMP -DCPUS=2' \
		crafty-make

linux-icc:
	$(MAKE) target=LINUX \
		CC=icc CXX=icc \
		CFLAGS='$(CFLAGS) -D_REENTRANT -O2 \
                        -xN -prof_use -prof_dir ./profdir \
                        -Ob2 -fno-alias' \
		CXFLAGS='$(CFLAGS) -D_REENTRANT -O2 \
                        -w -xN -prof_use -prof_dir ./profdir' \
		LDFLAGS='$(LDFLAGS) -lpthread' \
		opt='$(opt) -DFUTILITY -DFAST -DINLINE_ASM \
                         -DPOSIX -DSMP -DCPUS=2' \
		crafty-make

linux-alpha:
	$(MAKE) target=ALPHA \
		CC=gcc CXX=g++ \
		CFLAGS='$(CFLAGS) -O4 -ffast-math -funroll-loops' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS='$(LDFLAGS) $(CFLAGS)' \
		LIBS='-lpthread' \
		opt='$(opt) -DFUTILITY -DSMP -DCPUS=8 -DFAST -DPOSIX \
                         -DNOBUILTINS' \
		crafty-make

netbsd:
	$(MAKE) target=NetBSD \
		CC=gcc CXX=g++ \
		CFLAGS='$(CFLAGS) -D_REENTRANT -O3 -Wall \
			-fomit-frame-pointer -funroll-all-loops \
			-finline-functions -ffast-math' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS=$(LDFLAGS) \
		opt='$(opt) -DFUTILITY -DFAST' \
		crafty-make

netbsd-i386:
	$(MAKE) target=NetBSD \
		CC=gcc CXX=g++ \
		CFLAGS='$(CFLAGS) -D_REENTRANT -O3 -Wall -m486 \
			-fomit-frame-pointer -funroll-all-loops \
			-finline-functions -ffast-math' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS=$(LDFLAGS) \
		opt='$(opt) -DFUTILITY -DFAST -DUSE_ASSEMBLY' \
		crafty-make

netbsd-sparc:
	$(MAKE) target=NetBSD \
		CC=gcc CXX=g++ \
		CFLAGS='$(CFLAGS) -D_REENTRANT -O3 -Wall \
			-fomit-frame-pointer -funroll-all-loops \
			-finline-functions -ffast-math' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS=$(LDFLAGS) \
		opt='$(opt) -DFUTILITY -DFAST' \
		crafty-make

next:
	$(MAKE) target=NEXT \
		CC=/bin/cc CXX='$(CC)' \
		CFLAGS='$(CFLAGS) -O2' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS='$(LDFLAGS) $(CFLAGS)'
		opt='$(opt) -DFUTILITY' \
		crafty-make

os2:
	$(MAKE) target=OS2 \
		CC=gcc CXX='$(CC)' \
		CFLAGS='$(CFLAGS) -fomit-frame-pointer -m486 -O3 -Wall' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS='$(LDFLAGS) -Zexe -Zcrtdll -s' \
		opt='$(opt) -DFUTILITY -DUSE_ASSEMBLY -DFAST' \
		crafty-make

sgi:
	$(MAKE) target=SGI \
		AS=/bin/as CC=cc CXX='$(CC)' \
		AFLAGS='-P' \
		CFLAGS='$(CFLAGS) -32 -mips2 -cckr' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS=$(LDFLAGS) \
		opt='$(opt) -DFUTILITY' \
		crafty-make

solaris:
	$(MAKE) target=SUN \
		AS=/usr/ccs/bin/as CC=cc CXX='$(CC)' \
		AFLAGS='-P' \
		CFLAGS='$(CFLAGS) -fast -xO5 -xunroll=20' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS='$(LDFLAGS) -lpthread' \
		opt='$(opt) -DFUTILITY -DSMP -DCPUS=4 -DMUTEX -DPOSIX' \
		crafty-make

solaris-gcc:
	$(MAKE) target=SUN \
		AS=/usr/ccs/bin/as CC=gcc CXX=g++ \
		AFLAGS='-P' \
		CFLAGS='$(CFLAGS) -Wall -pipe -D_REENTRANT -O2 \
			-fforce-mem -fomit-frame-pointer' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS='$(LDFLAGS) -lstdc++' \
		opt='$(opt) -DFUTILITY -DFAST' \
		crafty-make

generic:
	$(MAKE) CC=gcc CXX=g++ \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS=$(LDFLAGS) \
		crafty-make

profile:
	@rm -rf profdir
	@rm -rf position.bin
	@mkdir profdir
	@touch *.c *.cpp *.h
	$(MAKE) linux-icc-profile
